org.apache.commons.text.lookup

## Class StringLookupFactory

- java.lang.Object
- - org.apache.commons.text.lookup.StringLookupFactory

-     public final class StringLookupFactory
      extends Object

  Provides access to lookups defined in this package.
  Since:
    1.3

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static StringLookupFactory` | `INSTANCE` Defines the singleton for this class.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `StringLookup` | `dateStringLookup()` Returns the DateStringLookup singleton instance to format the current date with the format given in the key in a format compatible with `SimpleDateFormat`.
    `StringLookup` | `environmentVariableStringLookup()` Returns the EnvironmentVariableStringLookup singleton instance where the lookup key is an environment variable name.
    `StringLookup` | `interpolatorStringLookup()` Returns a new InterpolatorStringLookup.
    `StringLookup` | `interpolatorStringLookup(Map<String,StringLookup> stringLookupMap, StringLookup defaultStringLookup, boolean addDefaultLookups)` Returns a new InterpolatorStringLookup.
    `<V> StringLookup` | `interpolatorStringLookup(Map<String,V> map)` Returns a new InterpolatorStringLookup.
    `StringLookup` | `interpolatorStringLookup(StringLookup defaultStringLookup)` Returns a new InterpolatorStringLookup.
    `StringLookup` | `javaPlatformStringLookup()` Returns the JavaPlatformStringLookup singleton instance.
    `StringLookup` | `localHostStringLookup()` Returns the LocalHostStringLookup singleton instance where the lookup key is one of: name: for the local host name, for example `EXAMPLE`. canonical-name: for the local canonical host name, for example `EXAMPLE.apache.org`. address: for the local host address, for example `192.168.56.1`.
    `<V> StringLookup` | `mapStringLookup(Map<String,V> map)` Returns a new map-based lookup where the request for a lookup is answered with the value for that key.
    `StringLookup` | `nullStringLookup()` Returns the NullStringLookup singleton instance which always returns null.
    `StringLookup` | `resourceBundleStringLookup()` Returns the ResourceBundleStringLookup singleton instance.
    `StringLookup` | `systemPropertyStringLookup()` Returns the SystemPropertyStringLookup singleton instance where the lookup key is a system property name.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### INSTANCE

          public static final StringLookupFactory INSTANCE

      Defines the singleton for this class.

  - ### Method Detail

    - #### dateStringLookup

          public StringLookup dateStringLookup()

      Returns the DateStringLookup singleton instance to format the current date with the format given in the key in a format compatible with `SimpleDateFormat`.
      Returns:
        the DateStringLookup singleton instance.

    - #### environmentVariableStringLookup

          public StringLookup environmentVariableStringLookup()

      Returns the EnvironmentVariableStringLookup singleton instance where the lookup key is an environment variable name.
      Returns:
        the EnvironmentVariableStringLookup singleton instance.

    - #### interpolatorStringLookup

          public StringLookup interpolatorStringLookup()

      Returns a new InterpolatorStringLookup.

      The following lookups are used by default:

      - "sys" for the `SystemPropertyStringLookup`.
      - "env" for the `EnvironmentVariableStringLookup`.
      - "java" for the `JavaPlatformStringLookup`.
      - "date" for the `DateStringLookup`.
      - "localhost" for the `LocalHostStringLookup`, see `localHostStringLookup()` for key names.
      Returns:
        a new InterpolatorStringLookup.

    - #### interpolatorStringLookup

          public <V> StringLookup interpolatorStringLookup(Map<String,V> map)

      Returns a new InterpolatorStringLookup.

      The following lookups are used by default:

      - "sys" for the `SystemPropertyStringLookup`.
      - "env" for the `EnvironmentVariableStringLookup`.
      - "java" for the `JavaPlatformStringLookup`.
      - "date" for the `DateStringLookup`.
      - "localhost" for the `LocalHostStringLookup`, see `localHostStringLookup()` for key names.
      Type Parameters:
        `V` - the value type the default string lookup's map.
      Parameters:
        `map` - the default map for string lookups.
      Returns:
        a new InterpolatorStringLookup.

    - #### interpolatorStringLookup

          public StringLookup interpolatorStringLookup(StringLookup defaultStringLookup)

      Returns a new InterpolatorStringLookup.

      The following lookups are used by default:

      - "sys" for the `SystemPropertyStringLookup`.
      - "env" for the `EnvironmentVariableStringLookup`.
      - "java" for the `JavaPlatformStringLookup`.
      - "date" for the `DateStringLookup`.
      - "localhost" for the `LocalHostStringLookup`, see `localHostStringLookup()` for key names.
      Parameters:
        `defaultStringLookup` - the default string lookup.
      Returns:
        a new InterpolatorStringLookup.

    - #### interpolatorStringLookup

          public StringLookup interpolatorStringLookup(Map<String,StringLookup> stringLookupMap,
                                                       StringLookup defaultStringLookup,
                                                       boolean addDefaultLookups)

      Returns a new InterpolatorStringLookup.

      If `addDefaultLookups` is true, the following lookups are used in addition to the ones provided in `stringLookupMap`:

      - "sys" for the `SystemPropertyStringLookup`.
      - "env" for the `EnvironmentVariableStringLookup`.
      - "java" for the `JavaPlatformStringLookup`.
      - "date" for the `DateStringLookup`.
      - "localhost" for the `LocalHostStringLookup`, see `localHostStringLookup()` for key names.
      Parameters:
        `stringLookupMap` - the map of string lookups.
        `defaultStringLookup` - the default string lookup.
        `addDefaultLookups` - whether to use lookups as described above.
      Returns:
        a new InterpolatorStringLookup.
      Since:
        1.4

    - #### javaPlatformStringLookup

          public StringLookup javaPlatformStringLookup()

      Returns the JavaPlatformStringLookup singleton instance.
      Returns:
        the JavaPlatformStringLookup singleton instance.

    - #### localHostStringLookup

          public StringLookup localHostStringLookup()

      Returns the LocalHostStringLookup singleton instance where the lookup key is one of:
      - name: for the local host name, for example `EXAMPLE`.
      - canonical-name: for the local canonical host name, for example `EXAMPLE.apache.org`.
      - address: for the local host address, for example `192.168.56.1`.
      Returns:
        the DateStringLookup singleton instance.

    - #### mapStringLookup

          public <V> StringLookup mapStringLookup(Map<String,V> map)

      Returns a new map-based lookup where the request for a lookup is answered with the value for that key.
      Type Parameters:
        `V` - the map value type.
      Parameters:
        `map` - the map.
      Returns:
        a new MapStringLookup.

    - #### nullStringLookup

          public StringLookup nullStringLookup()

      Returns the NullStringLookup singleton instance which always returns null.
      Returns:
        the NullStringLookup singleton instance.

    - #### resourceBundleStringLookup

          public StringLookup resourceBundleStringLookup()

      Returns the ResourceBundleStringLookup singleton instance.

      Looks up the value for a given key in the format "BundleName:BundleKey".

      For example: "com.domain.messages:MyKey".

      Returns:
        the ResourceBundleStringLookup singleton instance.

    - #### systemPropertyStringLookup

          public StringLookup systemPropertyStringLookup()

      Returns the SystemPropertyStringLookup singleton instance where the lookup key is a system property name.
      Returns:
        the SystemPropertyStringLookup singleton instance.

Copyright © 2014–2018 The Apache Software Foundation. All rights reserved.